/* CFG Easter by mut2nt@2009
* -= CVARS =-
* ----------------------------------------
* cfg_easter_model 0/1 - Dezactivat/Activat - Inlocuieste modelul la bomba cu un ou de pasti
* cfg_easter_sound 0/1 - Dezactivat/Activat - Cand planteaza/dezamorseza/explodeaza c4 se aud sunete diferite
* cfg_easter_lights 0/1 - Dezactivat/Activat - Cand planteaza / dezamorseaza/explodeaza c4 se schimba luminozitatea hartii dupa care revine la normal in runda noua
* cfg_easter_msg 0/1/2 - Dezactivat/Activat in chat/ Activat in hud - Cand planteaza / dezamorseaza/explodeaza c4 se activeaza anumite msg-e in chat sau hud
* ----------------------------------------
*
* For more plugins visit
* www.eXtreamCS.com/forum
*/

#include < amxmodx >
#include < fakemeta >
#include < cfg_chat >

new const BombModels [ ][ ] = 
{
	"models/easteregg.mdl",
	"models/easteregg1.mdl",
	"models/easteregg2.mdl"
};

new toggle_model, toggle_sound, toggle_lights, toggle_msg;

public plugin_init( ) 
{
	register_plugin("cfg_easter", "1.1", "mut2nt");
	register_cvar("CFG Easter", "1.1/mut2nt", FCVAR_SERVER);

	register_forward(FM_SetModel, "fwd_SetModel", 1);

	register_logevent("BombPlanted", 3, "2=Planted_The_Bomb");
	register_logevent("BombDefused", 3, "2=Defused_The_Bomb");
	register_logevent("BombExploded", 6, "3=Target_Bombed");

	toggle_model = register_cvar("cfg_easter_model", "1");
	toggle_sound = register_cvar("cfg_easter_sound", "1");
	toggle_lights = register_cvar("cfg_easter_lights", "1");
	toggle_msg = register_cvar("cfg_easter_msg", "1");

	g_msgsaytext = get_user_msgid("SayText");
}

public plugin_precache()
{
	for(new i = 0 ; i < sizeof BombModels ; i++)
	{
		precache_model(BombModels[i]);
	}

	precache_sound("misc/egg_defused.mp3");
	precache_sound("misc/egg_explode.mp3");
	precache_sound("misc/egg_planted.mp3");
}

public fwd_SetModel(ent, const Model[])
{
	if(!pev_valid(ent) || get_pcvar_num(toggle_model) == 0)
	{
		return FMRES_IGNORED;
	}

	if(equal(Model, "models/w_c4.mdl"))
	{
		static w;
		w = random_num(0, sizeof BombModels - 1);
		engfunc(EngFunc_SetModel, ent, BombModels[w]);
		
		return FMRES_SUPERCEDE;
	}
	return FMRES_IGNORED;
}

public BombPlanted()
{
	switch(get_pcvar_num(toggle_msg))
	{
		case 0:
		{
		}

		case 1:
		{
			print(0,"^x01[^x04C4 Event^x01]^x03 Iepurasul^x01 a adus cadoul la destinatie");
		}

		case 2:
		{
			set_hudmessage(255, 0, 0, -1.0, 0.06, 1, 6.0, 6.0, 1.0, 1.0, 2);
			show_hudmessage(0, "Iespurasul a adus cadoul la destinatie");
		}
	}

	if (get_pcvar_num(toggle_lights) != 0)
	{
		lights("d");
	}

	if (get_pcvar_num(toggle_sound) != 0)
	{
		client_cmd(0, "wait;stopsound");
		client_cmd(0,"mp3 play sound/misc/egg_planted.mp3");
	}
}

public BombDefused()
{
	switch(get_pcvar_num(toggle_msg))
	{
		case 0:
		{
		}

		case 1:
		{
			print(0,"^x01[^x04C4 Event^x01]^x03 AMINNNNNNNN");
		}

		case 2:
		{
			set_hudmessage(255, 0, 0, -1.0, 0.06, 1, 6.0, 6.0, 1.0, 1.0, 2);
			show_hudmessage(0, "AMINNNNNNN");
		}
	}

	if (get_pcvar_num(toggle_lights) != 0)
	{
		set_task(2.0,"normal");
	}

	if (get_pcvar_num(toggle_sound) != 0)
	{
		client_cmd(0, "wait;stopsound");
		client_cmd(0,"mp3 play sound/misc/egg_defused.mp3");

	}
}

public BombExploded()
{
	switch(get_pcvar_num(toggle_msg))
	{
		case 0:
		{
		}

		case 1:
		{
			print(0,"^x01[^x04C4 Event^x01]^x03 Hristos^x01 a^x04 INVIAT^x01!");
		}

		case 2:
		{
			set_hudmessage(255, 0, 0, -1.0, 0.06, 1, 6.0, 6.0, 1.0, 1.0, 2);
			show_hudmessage(0, "Hristos a INVIAT!");
		}
	}

	if (get_pcvar_num(toggle_lights) != 0)
	{
		lights("b");
		set_task(5.0,"normal");
	}

	if (get_pcvar_num(toggle_sound) != 0)
	{
		client_cmd(0, "wait;stopsound");
		client_cmd(0,"mp3 play sound/misc/egg_explode.mp3");
	}
}

public normal()
{
	lights("n");
}

stock lights(const light[])
{
	return engfunc(EngFunc_LightStyle,0,light);
}